// @(#)root/reflex:$Name:$:$Id:$
// Author: Pere Mato 2005
#ifndef ROOT_Cintex_Cintex
#define ROOT_Cintex_Cintex

#include "Reflex/Callback.h"
#include "Reflex/Type.h"
#include "Reflex/Member.h"

// ROOT forward declarations
namespace ROOT { class TGenericClassInfo; }
class TClass;


namespace ROOT {
  namespace Cintex {
    
    struct Callback : public ROOT::Reflex::ICallback {
      virtual void operator () ( const ROOT::Reflex::Type& t );
      virtual void operator () ( const ROOT::Reflex::Member& m );
    };

    typedef TClass* (*ROOTCreator)( ROOT::Reflex::Type, ROOT::TGenericClassInfo* );
 
    class Cintex {
    public:
      Cintex();
      ~Cintex();
      static void Enable();
      static void SetROOTCreator(ROOTCreator);
      static ROOTCreator GetROOTCreator();
      static int  Debug();
      static void SetDebug(int);
    private:
      static Cintex& Instance();
      Callback*     fCallback;
      ROOTCreator   fRootcreator;
      int           fDbglevel;
    };

  }
}
#endif // ROOT_Cintex_Cintex
